PDTHHudCoreDefinitions = PDTHHudCoreDefinitions or class()

function PDTHHudCoreDefinitions:init()
    self.weapon_texture = {
        textures = {
            "guis/textures/pdth_hud/icons_black",
            "guis/textures/pdth_hud/icons_coloured"
        },
        icon_size = {w=160, h=160},
        texture_size = {w=1600, h=3200},
        weapon_order = {
            "ak74",
            "akm",
            "ak5",
            "amcar",
            "m16",
            "tecci",
            "new_m4",
            "sub2000",
            "famas",
            "s552",
            "scar",
            "fal",
            "galil",
            "g3",
            "akm_gold",
            "g36",
            "vhs",
            "new_m14",
            "l85a2",
            "aug",
            "asval",
            "saiga",
            "b682",
            "benelli",
            "hunstman",
            "spas12",
            "ksg",
            "r870",
            "aa12",
            "wa2000",
            "mosin",
            "model70",
            "r93",
            "msr",
            "winchester1874",
            "m95",
            "long",
            "flamethrower_mk2",
            "gre_m79",
            "arblast",
            "frankish",
            "saw",
            "m32",
            "plainsrider",
            "m134",
            "hk21",
            "mg42",
            "m249",
            "par",
            "rpk",
            "x_b92fs",
            "x_g17",
            "jowi",
            "x_g22c",
            "x_mp5",
            "x_1911",
            "x_deagle",
            "x_sr2",
            "x_usp",
            "x_akmsu",
            "china",
            "rpg7",
            "hunter",
            "m37",
            "serbu",
            "striker",
            "judge",
            "sparrow",
            "b92fs",
            "new_raging_bull",
            "c96",
            "glock_17",
            "g26",
            "g22c",
            "colt_1911",
            "deagle",
            "ppk",
            "usp",
            "hs2000",
            "mateba",
            "peacemaker",
            "p226",
            "glock_18c",
            "pl14",
            "tec9",
            "m1928",
            "mp9",
            "scorpion",
            "new_mp5",
            "sr2",
            "cobray",
            "p90",
            "akmsu",
            "polymer",
            "mac10",
            "baka",
            "olympic",
            "sterling",
            "mp7",
            "m45",
            "uzi",
            "frag_grenade",
            "dynamite_grenade",
            "four_projectile",
            "jav_projectile",
            "molotov_grenade",
            "ace_projectile",
            "alien_maul",
            "ballistic",
            "barbedwire",
            "baseballbat",
            "baton",
            "bayonet",
            "beardy",
            "becker",
            "bowie",
            "boxcutter",
            "boxing_gloves",
            "branding_iron",
            "brass_knuckles",
            "briefcase",
            "buck",
            "bullseye",
            "chef",
            "cleaver",
            "cqc",
            "croupier_rake",
            "cutters",
            "detector",
            "dingdong",
            "fairbair",
            "fight",
            "fireaxe",
            "fists",
            "fork",
            "freedom",
            "gator",
            "gerber",
            "great",
            "hammer",
            "hockey",
            "iceaxe",
            "kabar",
            "kabartanto",
            "kampfmesser",
            "machete",
            "meat_cleaver",
            "microphone",
            "micstand",
            "mining_pick",
            "model24",
            "moneybundle",
            "morning",
            "nin",
            "oldbaton",
            "pitchfork",
            "poker",
            "pugio",
            "rambo",
            "sandsteel",
            "scalper",
            "scoutknife",
            "selfie",
            "shawn",
            "shillelagh",
            "shovel",
            "slot_lever",
            "spatula",
            "stick",
            "swagger",
            "switchblade",
            "taser",
            "tenderizer",
            "tiger",
            "tomahawk",
            "toothbrush",
            "twins",
            "whiskey",
            "wing",
            "x46",
            "zeus",
            "equipment_ammo_bag",
            "equipment_doctor_bag",
            "equipment_ecm_jammer",
            "equipment_first_aid_kit",
            "equipment_sentry_silent",
            "equipment_trip_mine",
            "equipment_armor_kit",
            "equipment_bodybags_bag",
            "weapon",
            "boot",
            "hajk",
            "equipment_sentry",
            "com_frag_grenade",
            "road",
            "throwing_axe",
            "contraband",
            "desertfox",
            "brick",
            "cs",
            "hobby_knife",
            "schakal",
            "packrat",
            "ray",
            "rota",
            "x_packrat",
            "concussion_grenade",
            "chico_injector"
        },
        category_conversion = {
            pistol = "glock_17",
            snp = "r93",
            shotgun = "r870",
            grenade_launcher = "gre_m79",
            smg = "p90",
            assault_rifle = "ak74",
            saw = "saw",
            lmg = "hk21",
            --minigun = "m134",
            flamethrower = "flamethrower_mk2",
            bow = "plainsrider",
            crossbow = "hunter",
            melee = "weapon"
        }
    }

    self.ammo = {
        pistol = "pistol_9mm",
        snp = "snp_44",
        shotgun = "shotgun_shell",
        grenade_launcher = "grenade",
        smg = "pistol_9mm",
        assault_rifle = "rifle_762",
        saw = "saw_blade",
        lmg = "rifle_762",
        minigun = "rifle_762",
        flamethrower = "fuel_tank",
        bow = "arrow",
        crossbow = "crossbow_bolt"
    }

    self.colour_gradings = {
        "color_payday",
        "color_heat",
        "color_nice",
        "color_sin",
        "color_bhd",
        "color_xgen",
        "color_xxxgen",
        "color_matrix",
    }
    self.heist_colour_gradings = {
        "color_main",
        "color_payday",
        "color_heat",
        "color_nice",
        "color_sin",
        "color_bhd",
        "color_xgen",
        "color_xxxgen",
        "color_matrix"
    }

    self.portrait_options = {}

    self.portrait_value_options = {}

    self.bullet_style_options = {
        "off",
        "normal",
        "coloured"
    }

    self.weapon_icon_style_options = {
    	"default",
    	"coloured"
    }
end
